; CDROM      Copyright (c)  Jannes Faber 1995
;
; You can contact me at :   faber@fys.ruu.nl
;           My www-page :   http://www.fys.ruu.nl/~faber
;
; This little program Opens & Closes your CD-ROM drive at the DOS-prompt.
;
; Syntax:       CDROM O         or      CDROM C
;
; It just opens or closes your drawer, or, if something isn't right, it 
; prints 'Err' on your screen. See the CDROM.TXT file for more info if things
; do go wrong !
;
; 04/16/1995:
;  I just received a routine from Robert Re from Canada to detect the name
;  of your CD-ROM driver. Of course I'd like to thank him for that ! I also
;  included his routine (unchanged) as a seperate file (GET_DRVR.ASM). It
;  assembles to a EXE-file and shows the name when run. If you here a beep,
;  there's something wrong (probably your driver has not been loaded !).
;
;  Here a updated version of my program that automatically detects the right
;  name and thus always opens or closes the cdrom. I did not try to make it
;  as small as possible this time, I just copied Robert's routine into it !
;
        .MODEL TINY
        .CODE

        Org     5Dh
Params  LABEL   BYTE

        .STARTUP

        jmp     SearchName            ; Use Robert Re's routine to find name

      ; Sorry for the dirty jmps, if you don't like it: fix it !

NameKnown:
        mov     cl, Params
        or      cl, 00100000y                   ; Convert to lowercase
        cmp     cl, 'o'
        jne     @F
        mov     cl, 0                           ; Open CD-rom
        jmp     OpenDev
@@:     cmp     cl, 'c'
        jne     Err
        mov     cl, 5                           ; Close CD-rom

OpenDev:
        ; Open Device using handle:
        mov     ax, 3D21h
        mov     dx, offset FileName
        int     21h
        jc      Err
        
        mov     ControlBlock, cl        ; Parameter Open or Close !

        mov     bx, ax                  ; file handle into bx
        mov     ax, 4403h               ; IOCTL function
        mov     cx, 1                   ; number of bytes to write
        ;mov     dx, offset ControlBlock ; 1 byte only to Open of Close
                                ; dx is already set: FileName == ControlBlock
        int     21h
        jnc     Einde

Err:    mov     dx, offset ShowErr      ; display error
        mov     ah, 9
        int     21h

Einde:  mov     ah, 4Ch                 ; exit program
        int     21h

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;get_drvr.asm
;program to search driver chain for matching string
;(I use Borland's TASM to assemble this into get_drvr.exe)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
programmer    db   "Robert Re"             ;
              db   "West Vancouver, Canada" ;
to_match      db   "MSCD"                   ;start of driver name

SearchName:   mov  ah,52h                   ;get "List of Lists"  from dos
              int  21h                      ;(undocumented dos function)
              add  bx,22h                   ;advance to NUL driver offset

;identify driver type: block or character type

chk_drvr:     test byte ptr es:[bx+5],80h   ;check driver type
              jz   next_drvr                ;jump if it is block device

;check character driver for match

              mov  si,offset to_match       ;point to string to match
              mov  di,bx                    ;point to driver offset
              add  di,10                    ;advance to driver name
              cmpsb                         ;compare first byte
              jnz  next_drvr                ;jump if no match

              mov  cx,3                     ;3 more character to match
next_char:    cmpsb                         ;compare next byte
              jnz  next_drvr                ;jump if not matched
              loop next_char                ;else keep going
              jmp  drvr_found               ;jump if complete match made

next_drvr:    mov  di,bx                    ;reload driver offset
              mov  bx,es:[di]               ;and get offset of next drvr
              cmp  bx,0ffffh                ;end of driver chain?
              jz   not_found                ;jump if no more to check
              mov  ax,es:[di+2]             ;else retrieve next segment
              mov  es,ax                    ;load in extra register
              jmp  chk_drvr                 ;then jump to check next driver

not_found:    jmp  err                      ;head for the exit

;transfer complete driver name to a buffer

drvr_found:   push ds                       ;save data segment

              push ds                       ;swap extra and data segment
              push es                       ;
              pop  ds                       ;
              pop  es                       ;

              mov  si,bx                    ;point source to driver offset
              add  si,10                    ;and advance to driver name to load

              mov  di,offset FileName       ;point to buffer to store name

              mov  cx,8                     ;name length=8 characters
              rep  movsb                    ;copy complete driver name

              pop  ds                       ;restore data segment

; continu to open/close the cdrom...
              jmp  NameKnown
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ShowErr         BYTE    'Err$'
ControlBlock    LABEL   BYTE      ; offset ControlBlock == offset FileName
FileName        BYTE    'MSCD000 ', 0, 0
                
                END
